SDL_cpuinfo.h File Reference
`#include "SDL_stdinc.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_cpuinfo.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | SDL_CACHELINE_SIZE 128

## Functions

int | SDL_GetCPUCount (void)
int | SDL_GetCPUCacheLineSize (void)
SDL_bool | SDL_HasRDTSC (void)
SDL_bool | SDL_HasAltiVec (void)
SDL_bool | SDL_HasMMX (void)
SDL_bool | SDL_Has3DNow (void)
SDL_bool | SDL_HasSSE (void)
SDL_bool | SDL_HasSSE2 (void)
SDL_bool | SDL_HasSSE3 (void)
SDL_bool | SDL_HasSSE41 (void)
SDL_bool | SDL_HasSSE42 (void)
SDL_bool | SDL_HasAVX (void)
SDL_bool | SDL_HasAVX2 (void)
SDL_bool | SDL_HasAVX512F (void)
SDL_bool | SDL_HasARMSIMD (void)
SDL_bool | SDL_HasNEON (void)
SDL_bool | SDL_HasLSX (void)
SDL_bool | SDL_HasLASX (void)
int | SDL_GetSystemRAM (void)
size_t | SDL_SIMDGetAlignment (void)
void * | SDL_SIMDAlloc (const size_t len)
void * | SDL_SIMDRealloc (void *mem, const size_t len)
void | SDL_SIMDFree (void *ptr)

## Macro Definition Documentation

## SDL_CACHELINE_SIZE

#define SDL_CACHELINE_SIZE 128

# CategoryCPUInfo

CPU feature detection for SDL.

These functions are largely concerned with reporting if the system has access to various SIMD instruction sets, but also has other important info to share, such as number of logical CPU cores.

Definition at line 147 of file SDL_cpuinfo.h.

## Function Documentation

## SDL_GetCPUCacheLineSize()

int SDL_GetCPUCacheLineSize | ( | void |  | ) |

extern

Determine the L1 cache line size of the CPU.

This is useful for determining multi-threaded structure padding or SIMD prefetch sizes.

Returns
  the L1 cache line size of the CPU, in bytes.

Since
  This function is available since SDL 2.0.0.

## SDL_GetCPUCount()

int SDL_GetCPUCount | ( | void |  | ) |

extern

Get the number of CPU cores available.

Returns
  the total number of logical CPU cores. On CPUs that include technologies such as hyperthreading, the number of logical cores may be more than the number of physical cores.

Since
  This function is available since SDL 2.0.0.

## SDL_GetSystemRAM()

int SDL_GetSystemRAM | ( | void |  | ) |

extern

Get the amount of RAM configured in the system.

Returns
  the amount of RAM configured in the system in MiB.

Since
  This function is available since SDL 2.0.1.

## SDL_Has3DNow()

SDL_bool SDL_Has3DNow | ( | void |  | ) |

extern

Determine whether the CPU has 3DNow! features.

This always returns false on CPUs that aren't using AMD instruction sets.

Returns
  SDL_TRUE if the CPU has 3DNow! features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_HasAltiVec
  SDL_HasAVX
  SDL_HasAVX2
  SDL_HasMMX
  SDL_HasRDTSC
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasAltiVec()

SDL_bool SDL_HasAltiVec | ( | void |  | ) |

extern

Determine whether the CPU has AltiVec features.

This always returns false on CPUs that aren't using PowerPC instruction sets.

Returns
  SDL_TRUE if the CPU has AltiVec features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_Has3DNow
  SDL_HasAVX
  SDL_HasAVX2
  SDL_HasMMX
  SDL_HasRDTSC
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasARMSIMD()

SDL_bool SDL_HasARMSIMD | ( | void |  | ) |

extern

Determine whether the CPU has ARM SIMD (ARMv6) features.

This is different from ARM NEON, which is a different instruction set.

This always returns false on CPUs that aren't using ARM instruction sets.

Returns
  SDL_TRUE if the CPU has ARM SIMD features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.12.

See also
  SDL_HasNEON

## SDL_HasAVX()

SDL_bool SDL_HasAVX | ( | void |  | ) |

extern

Determine whether the CPU has AVX features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has AVX features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.2.

See also
  SDL_Has3DNow
  SDL_HasAltiVec
  SDL_HasAVX2
  SDL_HasMMX
  SDL_HasRDTSC
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasAVX2()

SDL_bool SDL_HasAVX2 | ( | void |  | ) |

extern

Determine whether the CPU has AVX2 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has AVX2 features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.4.

See also
  SDL_Has3DNow
  SDL_HasAltiVec
  SDL_HasAVX
  SDL_HasMMX
  SDL_HasRDTSC
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasAVX512F()

SDL_bool SDL_HasAVX512F | ( | void |  | ) |

extern

Determine whether the CPU has AVX-512F (foundation) features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has AVX-512F features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.9.

See also
  SDL_HasAVX

## SDL_HasLASX()

SDL_bool SDL_HasLASX | ( | void |  | ) |

extern

Determine whether the CPU has LASX (LOONGARCH SIMD) features.

This always returns false on CPUs that aren't using LOONGARCH instruction sets.

Returns
  SDL_TRUE if the CPU has LOONGARCH LASX features or SDL_FALSE if not.

Since
  This function is available since SDL 2.24.0.

## SDL_HasLSX()

SDL_bool SDL_HasLSX | ( | void |  | ) |

extern

Determine whether the CPU has LSX (LOONGARCH SIMD) features.

This always returns false on CPUs that aren't using LOONGARCH instruction sets.

Returns
  SDL_TRUE if the CPU has LOONGARCH LSX features or SDL_FALSE if not.

Since
  This function is available since SDL 2.24.0.

## SDL_HasMMX()

SDL_bool SDL_HasMMX | ( | void |  | ) |

extern

Determine whether the CPU has MMX features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has MMX features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_Has3DNow
  SDL_HasAltiVec
  SDL_HasAVX
  SDL_HasAVX2
  SDL_HasRDTSC
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasNEON()

SDL_bool SDL_HasNEON | ( | void |  | ) |

extern

Determine whether the CPU has NEON (ARM SIMD) features.

This always returns false on CPUs that aren't using ARM instruction sets.

Returns
  SDL_TRUE if the CPU has ARM NEON features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.6.

## SDL_HasRDTSC()

SDL_bool SDL_HasRDTSC | ( | void |  | ) |

extern

Determine whether the CPU has the RDTSC instruction.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has the RDTSC instruction or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_Has3DNow
  SDL_HasAltiVec
  SDL_HasAVX
  SDL_HasAVX2
  SDL_HasMMX
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasSSE()

SDL_bool SDL_HasSSE | ( | void |  | ) |

extern

Determine whether the CPU has SSE features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has SSE features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_Has3DNow
  SDL_HasAltiVec
  SDL_HasAVX
  SDL_HasAVX2
  SDL_HasMMX
  SDL_HasRDTSC
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasSSE2()

SDL_bool SDL_HasSSE2 | ( | void |  | ) |

extern

Determine whether the CPU has SSE2 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has SSE2 features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_Has3DNow
  SDL_HasAltiVec
  SDL_HasAVX
  SDL_HasAVX2
  SDL_HasMMX
  SDL_HasRDTSC
  SDL_HasSSE
  SDL_HasSSE3
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasSSE3()

SDL_bool SDL_HasSSE3 | ( | void |  | ) |

extern

Determine whether the CPU has SSE3 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has SSE3 features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_Has3DNow
  SDL_HasAltiVec
  SDL_HasAVX
  SDL_HasAVX2
  SDL_HasMMX
  SDL_HasRDTSC
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE41
  SDL_HasSSE42

## SDL_HasSSE41()

SDL_bool SDL_HasSSE41 | ( | void |  | ) |

extern

Determine whether the CPU has SSE4.1 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has SSE4.1 features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_Has3DNow
  SDL_HasAltiVec
  SDL_HasAVX
  SDL_HasAVX2
  SDL_HasMMX
  SDL_HasRDTSC
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE42

## SDL_HasSSE42()

SDL_bool SDL_HasSSE42 | ( | void |  | ) |

extern

Determine whether the CPU has SSE4.2 features.

This always returns false on CPUs that aren't using Intel instruction sets.

Returns
  SDL_TRUE if the CPU has SSE4.2 features or SDL_FALSE if not.

Since
  This function is available since SDL 2.0.0.

See also
  SDL_Has3DNow
  SDL_HasAltiVec
  SDL_HasAVX
  SDL_HasAVX2
  SDL_HasMMX
  SDL_HasRDTSC
  SDL_HasSSE
  SDL_HasSSE2
  SDL_HasSSE3
  SDL_HasSSE41

## SDL_SIMDAlloc()

void * SDL_SIMDAlloc | ( | const size_t | len | ) |

extern

Allocate memory in a SIMD-friendly way.

This will allocate a block of memory that is suitable for use with SIMD instructions. Specifically, it will be properly aligned and padded for the system's supported vector instructions.

The memory returned will be padded such that it is safe to read or write an incomplete vector at the end of the memory block. This can be useful so you don't have to drop back to a scalar fallback at the end of your SIMD processing loop to deal with the final elements without overflowing the allocated buffer.

You must free this memory with SDL_FreeSIMD(), not free() or SDL_free() or delete[], etc.

Note that SDL will only deal with SIMD instruction sets it is aware of; for example, SDL 2.0.8 knows that SSE wants 16-byte vectors (SDL_HasSSE()), and AVX2 wants 32 bytes (SDL_HasAVX2()), but doesn't know that AVX-512 wants

1. To be clear: if you can't decide to use an instruction set with an SDL_Has*() function, don't use that instruction set with memory allocated through here.

SDL_AllocSIMD(0) will return a non-NULL pointer, assuming the system isn't out of memory, but you are not allowed to dereference it (because you only own zero bytes of that buffer).

Parameters

  len | The length, in bytes, of the block to allocate. The actual allocated block might be larger due to padding, etc.

Returns
  a pointer to the newly-allocated block, NULL if out of memory.

Since
  This function is available since SDL 2.0.10.

See also
  SDL_SIMDGetAlignment
  SDL_SIMDRealloc
  SDL_SIMDFree

## SDL_SIMDFree()

void SDL_SIMDFree | ( | void * | ptr | ) |

extern

Deallocate memory obtained from SDL_SIMDAlloc

It is not valid to use this function on a pointer from anything but SDL_SIMDAlloc() or SDL_SIMDRealloc(). It can't be used on pointers from malloc, realloc, SDL_malloc, memalign, new[], etc.

However, SDL_SIMDFree(NULL) is a legal no-op.

The memory pointed to by ptr is no longer valid for access upon return, and may be returned to the system or reused by a future allocation. The pointer passed to this function is no longer safe to dereference once this function returns, and should be discarded.

Parameters

  ptr | The pointer, returned from SDL_SIMDAlloc or SDL_SIMDRealloc, to deallocate. NULL is a legal no-op.

Since
  This function is available since SDL 2.0.10.

See also
  SDL_SIMDAlloc
  SDL_SIMDRealloc

## SDL_SIMDGetAlignment()

size_t SDL_SIMDGetAlignment | ( | void |  | ) |

extern

Report the alignment this system needs for SIMD allocations.

This will return the minimum number of bytes to which a pointer must be aligned to be compatible with SIMD instructions on the current machine. For example, if the machine supports SSE only, it will return 16, but if it supports AVX-512F, it'll return 64 (etc). This only reports values for instruction sets SDL knows about, so if your SDL build doesn't have SDL_HasAVX512F(), then it might return 16 for the SSE support it sees and not 64 for the AVX-512 instructions that exist but SDL doesn't know about. Plan accordingly.

Returns
  the alignment in bytes needed for available, known SIMD instructions.

Since
  This function is available since SDL 2.0.10.

## SDL_SIMDRealloc()

void * SDL_SIMDRealloc | ( | void * | mem,
|  | const size_t | len )

extern

Reallocate memory obtained from SDL_SIMDAlloc

It is not valid to use this function on a pointer from anything but SDL_SIMDAlloc(). It can't be used on pointers from malloc, realloc, SDL_malloc, memalign, new[], etc.

Parameters

  mem | The pointer obtained from SDL_SIMDAlloc. This function also accepts NULL, at which point this function is the same as calling SDL_SIMDAlloc with a NULL pointer.
  len | The length, in bytes, of the block to allocated. The actual allocated block might be larger due to padding, etc. Passing 0 will return a non-NULL pointer, assuming the system isn't out of memory.

Returns
  a pointer to the newly-reallocated block, NULL if out of memory.

Since
  This function is available since SDL 2.0.14.

See also
  SDL_SIMDGetAlignment
  SDL_SIMDAlloc
  SDL_SIMDFree